require 'singleton'
#require 'browsermob/proxy'


module Scoutui::Base

  class QHarMgr
    include Singleton

    attr_accessor :proxy_binary
    attr_accessor :proxy
    attr_accessor :seleniumProfile


    def initialize()
      puts __FILE__ + (__LINE__).to_s + " -- start BrowserMob --" if Scoutui::Utils::TestUtils.instance.isDebug?
      @proxy_binary = BrowserMob::Proxy::Server.new(ENV['BROWSER_MOB_BIN'], { :port => 8088 })
    end

    def start()
      puts __FILE__ + (__LINE__).to_s + " --start --"
      @proxy_binary.start
      @proxy = @proxy_binary.create_proxy
      @seleniumProfile = @proxy.selenium_proxy  # Needed by Selenium instance

      @proxy.new_har(:capture_headers => true)
    end


    def getSeleniumProfile()
      puts __FILE__ + (__LINE__).to_s + " == getSeleniumProfile() => #{@seleniumProfile} --"
      @seleniumProfile
    end

    def stop(save_as=nil)
      puts __FILE__ + (__LINE__).to_s + " -- stop(#{save_as.to_s} --"
    #  @proxy.close

      if !save_as.nil?
        @proxy.har.save_to(save_as)
      end

      @proxy.close
    end

    def capture_traffic
     # @proxy.new_har
      yield
     @proxy.har
    end

    def run(n)
      puts __FILE__ + (__LINE__).to_s + " -- run --"
      @har = capture_traffic { yield }
#      @proxy.close
#      @har.save_to(n)
    end


  end


end
