

require 'singleton'
require 'DataMgr'

module Scoutui::Base

  class TestData
    include Singleton

    attr_accessor :testware
    attr_accessor :dblist
    attr_accessor :dut
    attr_accessor :jsList

    def initialize
      @testware={}
      @dblist={}
      @jsList={}
    end

    def addJS(_id, _content)
      Scoutui::Logger::LogMgr.instance.debug __FILE__ + (__LINE__).to_s + " addJS(#{_id}, #{_content})"
      @jsList[_id]=_content
      @jsList[_id]
    end

    def getJS(_id)
      @jsList[_id]
    end



    def add(_id, _f)
      Scoutui::Logger::LogMgr.instance.debug __FILE__ + (__LINE__).to_s + " add(#{_id}, #{_f})"
      @testware[_id]=DataMgr::DataModel.new(_f)

      Scoutui::Logger::LogMgr.instance.debug __FILE__ + (__LINE__).to_s + " => #{@testware[_id]}"
    end

    def addDB(_id, _f)
      rc=DataMgr::DB.instance.load(_f)
      if rc
        @dblist[_id]={}
      end
      Scoutui::Logger::LogMgr.instance.debug __FILE__ + (__LINE__).to_s + " addDB(#{_id}, #{_f}) : #{rc}"
      rc
    end

    def connectDB(_connectID)
      is_connected=false
      begin
          hit=DataMgr::DB.instance.getConfig(_connectID)

          puts __FILE__ + (__LINE__).to_s + " ** hit => #{hit}"
          is_connected=DataMgr::DB.instance.connect(_connectID)

      rescue => ex
        Scoutui::Logger::LogMgr.instance.debug __FILE__ + (__LINE__).to_s + " Exception #{ex.class}"
        Scoutui::Logger::LogMgr.instance.debug ex.backtrace
      end

      Scoutui::Logger::LogMgr.instance.debug __FILE__ + (__LINE__).to_s + " connectDB(#{_connectID}) : #{is_connected}"
      is_connected
    end

    def addx(_id, _reqs)
      Scoutui::Logger::LogMgr.instance.debug __FILE__ + (__LINE__).to_s + " add(#{_id}, #{_reqs}"
      @requirements[_id]=_reqs
    end

    def get(_id, _locator)
      rc=@testware[_id].getDataElement(_locator)
      Scoutui::Logger::LogMgr.instance.debug __FILE__ + (__LINE__).to_s + " get(#{_id}, #{_locator}) : #{rc}"
      rc
    end

  end





end
