require 'benchmark'

module Scoutui::Commands

  class Command
    attr_accessor :description
    attr_accessor :drv
    attr_accessor :cmd
    attr_accessor :rc
    attr_accessor :locator
    attr_accessor :executed
    attr_accessor :executed_result
    attr_accessor :stanza
    attr_accessor :bm
    attr_accessor :enableAssert

    def initialize(_cmd, _drv=nil)
      Scoutui::Logger::LogMgr.instance.commands.debug __FILE__ + (__LINE__).to_s + "  Command.init: #{_cmd.to_s}"

      @enableAssert=true
      @bm=nil
      @cmd=_cmd

      if _cmd.is_a?(Hash) && _cmd.has_key?('page') && _cmd['page'].has_key?('action')
        @stanza = _cmd
        @cmd=_cmd['page']['action']
      end

      @rc=nil
      @drv=_drv
      @locator=nil
      @executed=false
      @executed_result=nil
    end

    def assert?
      @enableAssert
    end

    def enableAssert()
      enableAsserts()
    end
    def enableAsserts()
      @enableAssert=true
    end
    def disableAssert()
      disableAsserts
    end

    def disableAsserts()
      @enableAssert=false
    end

    def setResult(r)
      Scoutui::Logger::LogMgr.instance.debug __FILE__ + (__LINE__).to_s + " setResult(#{r}) - #{@cmd.to_s}"
      Scoutui::Logger::LogMgr.instance.commands.debug " #{@cmd.to_s} : setResult(#{r.to_s})"
      @executed=true
      @executed_result=r
    end

    def executedResult
      @executed_result
    end

    def wasExecuted?
      @executed
    end

    def setLocator(_locator)
      @locator=_locator
    end

    def getLocator()
      @locator
    end

    def setBenchmark(b)
      @bm=b
    end

    def passed?
      !@executed_result.nil? && @executed_result
    end

    def result
      @rc
    end

    def run(opts) # (_drv=nil, _dut=nil)
      _drv=opts[:driver]
      _dut=opts.has_key?(:dut) ? opts[:dut] : nil

      Scoutui::Logger::LogMgr.instance.debug __FILE__ + (__LINE__).to_s + " = start run(#{@cmd}) ="
      @bm=Benchmark.measure { execute(_drv, _dut) }
      Scoutui::Logger::LogMgr.instance.debug __FILE__ + (__LINE__).to_s + " = end run(#{@cmd}) : #{@bm.real}"

      Scoutui::Logger::LogMgr.instance.benchmarks.info "#{@cmd} => #{@bm.real}"
    end

    def execute(_drv=nil, _dut=nil)
      raise NotImplementedError
    end

  end


end
